% OSCILLATEUR de VAN DER POL
% Script donnant le portrait de phase d'une trajectoire d'un pendule
% simple, d'aprs les conditions initiales rentres graphiquement.

clear
% Entre des CI
answer = inputdlg({'L ? ','m ?','g ?','t(max) ?','delta_t ?','Vitesse d''affichage'},...
    'Entrez les Conditions Initiales',1,{'0.5','0.1','10','10','0.01','9'});
L=str2num(answer{1});
m=str2num(answer{2});
ga=str2num(answer{3});
tm=str2num(answer{4});
delta_t=str2num(answer{5});
sp=str2num(answer{6});
t=0:delta_t:tm;

    figure('name',['Portrait de phase'],'Color',[1 1 1]) % Figure cre, et bloque
    hold on
    H=[ga/L,2*ga/L,3*ga/L,4*ga/L,5*ga/L,6*ga/L,7*ga/L,8*ga/L,12*ga/L]; % Diffrentes valeurs de l'hamiltonien du systme
    theta=[-2*pi:0.01:2*pi]; % Vecteur angle pour le graph du portrait de phase
    for i=1:length(H)
    dthetap(i,:)=+(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    dthetam(i,:)=-(H(i)-2*ga/L.*(1-cos(theta))).^0.5;
    plot(theta,real(dthetap),'k:',theta,real(dthetam),'k:'),xlim([-2*pi 2*pi]),ylim([-max(dthetap(length(H))) +max(dthetap(length(H)))]),xlabel('phi'),ylabel('phi''')
    end
[phi1,phi1p]=ginput(1); % Entre par le graphique des CI
c=2*m*L^2*(ga/L)^0.5; % valeur du frottement critique
t=0:delta_t:tm; % Intervalle d'tude 
answer = inputdlg({'k ? ','Angle Critique ?'},'Van der Pol',1,{num2str(c),'0'}); % Entre du coefficient de frottement
gamma=str2num(answer{1});
thetac=str2num(answer{2});

y(1,1)=phi1;y(2,1)=phi1p; % Vectorisation
f=inline('[y(2);-gamma/m*(y(1)^2/thetac^2-1)*y(2)-ga/L*sin(y(1))]','y','t','gamma','ga','L','m','thetac');

% Trac dynamique de la trajectoire.
for n=1:length(t)-1
    y(:,n+1)=y(:,n)+delta_t/2*f(y(:,n),t(n),gamma,ga,L,m,thetac)+delta_t/2*f(y(:,n)+delta_t*f(y(:,n),t(n),gamma,ga,L,m,thetac),t(n)+delta_t,gamma,ga,L,m,thetac);
if mod(n,sp)==0
    plot(y(1,1:n),y(2,1:n)),xlim([-2*pi 2*pi]),ylim([-max(dthetap(length(H))) +max(dthetap(length(H)))]),xlabel('phi'),ylabel('phi''')
drawnow
end
end
